Subject: Re: cygwin Rsync x32 issue
From: Brian Inglis <[email-masked]>
To: [email-masked]
Date: Sat, 13 Feb 2021 22:39:06 -0700
List-Id: General Cygwin discussions and problem reports <cygwin.cygwin.com>

On 2021-02-13 21:33, Jim Brain wrote:
> I perused the archive and did not see anything noted about this, but please 
> forgive me if it's been discussed.
> 
> Server: ubuntu 2004, running rsync 3.1.3 protocol version 31
> 
> client Windows 10 x64.
> 
> When calling rsync x64 3.2.4dev, transfer works fine.
> 
> When using rsync x32 3.2.4dev, downloaded last night, same transfer fails, with:
> 
> "
> 
> dup() in/out/err failed
> rsync: connection unexpectedly closed (0 bytes received so far) [sender]
> [sender] _exit_cleanup(code=12, file=io.c, line=228): entered
> rsync error: error in rsync protocol data stream (code 12) at io.c(228) 
> [sender=3.2.4dev]
> [sender] _exit_cleanup(code=12, file=io.c, line=228): about to call exit(12)
> 
> "
> 
> cwrsync fails in the same way.
> 
> Sadly, I would ignore and just use x64 rsync (as I normally do on my system 
> here), but this is to set up a sync job for a elderly user who wants to update 
> his web site and only has Windows x32 bit.
> 
> Any help would be most appreciated.  I can probably come up with an alternate 
> solution (scp or zip/ftp) but rsync seemed a clean approach to ensuring his 
> local version of the site and the web version stayed in sync.

Rsync is how Cygwin mirrors are maintained, so simple issues would have been 
reported, and checking would report mirror failures.

Please provide some info about your system per https://cygwin.com/problems.html
by running and attaching the output file as a text attachment to your reply:

$ cygcheck -hrsv > cygcheck.log

What edition and release of Win10 are you running? Home/Pro/... and e.g.

$ regtool list -v /proc/registry/HKEY_LOCAL_MACHINE/SYSTEM/Software/Microsoft/
CTF\ ()
BuildLab (REG_SZ) = "18362.19h1_release.190318-1202"
BuildLabEx (REG_SZ) = "18362.1.amd64fre.19h1_release.190318-1202"

What is your cygwin release from uname or /proc/version e.g.

$ uname -srvmo
CYGWIN_NT-10.0 3.1.7(0.340/5/3) 2020-08-22 17:48 x86_64 Cygwin
$ head /proc/version
CYGWIN_NT-10.0-18363 version 3.1.7-340.x86_64 (corinna@calimero) (gcc version 
9.3.0 20200312 (Fedora Cygwin 9.3.0-1) (GCC) ) 2020-08-22 17:48 UTC

What rsync version are you using e.g.

$ rsync --version
rsync  version 3.2.4dev  protocol version 31
Copyright (C) 1996-2020 by Andrew Tridgell, Wayne Davison, and others.
Web site: https://rsync.samba.org/
Capabilities:
     64-bit files, 64-bit inums, *64-bit timestamps*, 64-bit long ints,
     socketpairs, hardlinks, no hardlink-specials, symlinks, IPv6, atimes,
     batchfiles, inplace, append, ACLs, xattrs, optional protect-args, iconv,
     symtimes, prealloc, stop-at, no crtimes
Optimizations:
     no SIMD, asm, openssl-crypto
Checksum list:
     *xxh128 xxh3 xxh64 (xxhash)* md5 md4 none
Compress list:
     zstd lz4 zlibx zlib none

Cygwin 32 shows differences flagged above and below:

$ rsync --version
rsync  version 3.2.4dev  protocol version 31
Copyright (C) 1996-2020 by Andrew Tridgell, Wayne Davison, and others.
Web site: https://rsync.samba.org/
Capabilities:
     64-bit files, 64-bit inums, *32-bit timestamps*, 64-bit long ints,
     socketpairs, hardlinks, no hardlink-specials, symlinks, IPv6, atimes,
     batchfiles, inplace, append, ACLs, xattrs, optional protect-args, iconv,
     symtimes, prealloc, stop-at, no crtimes
Optimizations:
     no SIMD, no asm, openssl-crypto
Checksum list:
     md5 md4 none
Compress list:
     zstd lz4 zlibx zlib none

-- 
Take care. Thanks, Brian Inglis, Calgary, Alberta, Canada

This email may be disturbing to some readers as it contains
too much technical detail. Reader discretion is advised.
[Data in binary units and prefixes, physical quantities in SI.]
--
Problem reports:      https://cygwin.com/problems.html
FAQ:                  https://cygwin.com/faq/
Documentation:        https://cygwin.com/docs.html
Unsubscribe info:     https://cygwin.com/ml/#unsubscribe-simple